unit ShellFormViewUnit;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Controls,
    Forms,
    Dialogs,  
    SxShellViewForm,
    SxProvider, DB, DBTables, StdCtrls, Buttons, Grids, DBGrids, DBCtrls,
    ExtCtrls, FishInfoDialogUnit,
    PermanentModule, ComCtrls, SxShellListControl, Menus, SxPopupMenu;

type
  TShellViewForm = class(TSxShellViewForm)
    DataSource1: TDataSource;
    PanelItem: TPanel;
    Panel1: TPanel;
    DBLabel1: TDBText;
    DBImage1: TDBImage;
    Panel2: TPanel;
    Label1: TLabel;
    DBLabel2: TDBText;
    Panel3: TPanel;
    DBMemo1: TDBMemo;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    qryFish: TQuery;
    qryFishSpeciesNo: TFloatField;
    qryFishCategory: TStringField;
    qryFishCommon_Name: TStringField;
    qryFishSpeciesName: TStringField;
    qryFishLengthcm: TFloatField;
    qryFishLength_In: TFloatField;
    qryFishNotes: TMemoField;
    qryFishGraphic: TGraphicField;
    Button1: TButton;
    procedure SxShellViewFormClose(Sender: TObject;
      var Action: TCloseAction);
    procedure SxShellViewFormProcessItems(Sender: TSxShellViewForm;
      CurrentProvider: TSxCustomProvider; DataGrains: TSxDataGrainList);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

procedure TShellViewForm.SxShellViewFormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if qryFish.Active then qryFish.Close;
end;

procedure TShellViewForm.SxShellViewFormProcessItems(
  Sender: TSxShellViewForm; CurrentProvider: TSxCustomProvider;
  DataGrains: TSxDataGrainList);
var
  currentRootGrain: TSxCustomDataGrain;
begin
  currentRootGrain := ShellFolder.GetFolderGrain;
  try
    if qryFish.Active then qryFish.Close;
    qryFish.SQL.Clear;
    if Length(currentRootGrain.Name)>0 then
    begin
      qryFish.SQL.Add('SELECT * FROM biolife WHERE Category=:category ORDER BY Category, biolife."Species Name"');
      qryFish.ParamByName('category').AsString := currentRootGrain.Name;
    end
    else
      qryFish.SQL.Add('SELECT * FROM biolife ORDER BY Category, biolife."Species Name"');
    qryFish.Open;
  finally
    ShellFolder.ReleaseDataGrain(currentRootGrain);
  end;
end;

procedure TShellViewForm.Button1Click(Sender: TObject);
var
  tempFishInfoDialog:TFishInfoDialog;
begin
  tempFishInfoDialog:=TFishInfoDialog.Create(Self);
  try
    tempFishInfoDialog.Image1.Picture.Assign(DBImage1.Picture);
    tempFishInfoDialog.Description.Lines.Assign(DBMemo1.Lines);
    tempFishInfoDialog.ShowModal;
  finally
    FreeAndNil(tempFishInfoDialog);
  end;
end;

initialization
  RegisterShellViewFormClass(TShellViewForm);
end.

